package main

import (
	"log"

	"code.osinet.fr/fgm/kurz/api"
	_ "code.osinet.fr/fgm/kurz/migrations"
	"github.com/spf13/cobra"
	"github.com/spf13/viper"
)

var cmdServeAPI = &cobra.Command{
	Args:  cobra.NoArgs,
	Long:  "Serve Kurz as a JSON web API.",
	Run:   serveAPIHandler,
	Short: "Serve Kurz API",
	Use:   "api",
}

func init() {
	cmdServe.AddCommand(cmdServeAPI)
}

// Set up infrastructure and listen on specified address.
func serveAPIHandler(_ *cobra.Command, args []string) {
	db = ensureInfrastructure(db)
	defer db.Close()

	address := viper.Get("api.address").(string)
	err := api.ListenAndServe(address)
	log.Fatal(err)
}
